unit uspeed;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, fastfrm, ComCtrls, Grids, Math;

type
  TSpeedtest = class(TForm)
    FastFormula1: TFastFormula;
    Bevel1: TBevel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Bevel2: TBevel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Panel1: TPanel;
    Button1: TButton;
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FastFormula1ValidateParameter(Sender: TObject;
      Parameter: string; var Valid: Boolean);
  private
    { Private-Deklarationen }
    Iterations : LongInt;
    AktuelleZeile : LongInt;
    procedure Calculate(ALL:Boolean);
  public
    { Public-Deklarationen }
  end;

var
  Speedtest: TSpeedtest;

implementation

{$R *.DFM}

function Fact(N:Integer):Extended;
var I : Integer;
begin
   Result:=1;
   For i:=2 to N do Result:=Result*i;
end;

procedure TSpeedtest.FormCreate(Sender: TObject);
begin
   Iterations:=1000000;
   Panel1.Caption:=IntToStr(Iterations div 1000000)+'.000.000   ';
   StringGrid1.Cells[0,0]:='Formula';
   StringGrid1.Cells[1,0]:='Delphi';
   StringGrid1.Cells[2,0]:='TFastFormula';
   With ComboBox1.Items do
   begin
      Add('1.) sin(x)');
      Add('2.) cos(x)');
      Add('3.) arctan(x)');
      Add('4.) arcsin(x)');
      Add('5.) arccos(x)');
      Add('8.) arcsinh(x)');
      Add('9.) arccosh(x+1.0)');
      Add('11.) power(a,b)');
      Add('12.) fact(1000)');
      Add('13.) sin(x)*cos(x)*sin(x)');
   end;
   AktuelleZeile:=0;
end;

procedure TSpeedtest.TrackBar1Change(Sender: TObject);
begin
   Iterations:=(1+TrackBar1.Position)*1000000;
   Panel1.Caption:=IntToStr(Iterations div 1000000)+'.000.000   ';
end;

procedure TSpeedtest.Calculate(ALL:Boolean);
var x,y,z,a,b,c,d,RES : extended;
    x1,x2,x3,x4,x5,x6,x7 : extended;
    T1,T2,TR : TDateTime;
    i : longint;
    Hour,Min,Sec,MSec : Word;
    TimeString : String;
    Error : TFastFormulaError;
begin
   randomize;
   If not ALL then
   begin
      case ComboBox1.ItemIndex+1 of
       1 : begin
              // sin(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=sin(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='sin(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       2 : begin
              // cos(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=cos(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='cos(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       3 : begin
              // arctan(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=arctan(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='arctan(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       4 : begin
              // arcsin(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=arcsin(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='arcsin(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       5 : begin
              // arccos(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=arccos(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='arccos(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       6 : begin
              // arcsinh(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=arcsinh(random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='arcsinh(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       7 : begin
              // arccosh(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=arccosh(random+1.0);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='arccosh(x+1.0)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       8 : begin
              // power(a,b)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=power(random,random);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='power(a,b)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random,random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       9 : begin
              // fact(n)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=fact(1000);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='fact(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([1000]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
       10: begin
              // sin(x)*cos(x)*sin(x)
              StringGrid1.Cells[0,AktuelleZeile]:=ComboBox1.Items[ComboBox1.ItemIndex]+' ==> '+IntToStr(Iterations div 1000000)+'.000.000';
              Refresh;
              TR:=0;T1:=Time;
              For i:=1 to Iterations do
              begin
                 x:=random;
                 RES:=sin(x)*cos(x)*sin(x);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[1,AktuelleZeile]:=TimeString;
              Refresh;
              FastFormula1.Formula:='sin(x)*cos(x)*sin(x)';
              FastFormula1.Compile;
              TR:=0;
              T1:=Time;
              For i:=1 to Iterations do
              begin
                 RES:=FastFormula1.Calculate([random]);
              end;
              T2:=Time;
              TR:=T2-T1;
              DecodeTime(TR,hour,min,sec,msec);
              TimeString:=TimeToStr(TR)+':';
              If MSec<100 then TimeString:=TimeString+'0';
              If MSec<10 then TimeString:=TimeString+'0';
              TimeString:=TimeString+intToStr(MSec);
              StringGrid1.Cells[2,AktuelleZeile]:=TimeString;
              Refresh;
           end;
      end;
   end else
   begin

   end;
end;

procedure TSpeedtest.Button1Click(Sender: TObject);
begin
   inc(AktuelleZeile);
   If AktuelleZeile>StringGrid1.RowCount-1 then StringGrid1.RowCount:=StringGrid1.RowCount+1;
   Screen.Cursor:=crHourGlass;
   Calculate(FALSE);
   Screen.Cursor:=crArrow;
end;

procedure TSpeedtest.FastFormula1ValidateParameter(Sender: TObject;
  Parameter: string; var Valid: Boolean);
begin
   Valid:=TRUE;
end;

end.
